/* Save routines.
   Jarek 'Roeoender' Wosik
   contains:
     search_string
     address_modif
     open_file
   this program save data in dummy basic program*/
/* here is search string proc*/


#define NXTSEG 1024 /*used by search_string, every 1024 bytes it will switch to next (proprer) segment*/
#define BASIC_SEG 7200 /*this is segment where basic programs start in CASIO's RAM.*/
#define LASTSEGM 9152 /*144*1024 / 16 = 9216 probably this is not the last segment*/
/* something from older version, it used a buffer to write*/
/*#define FSIZE 255  /*whole file size, usable is FSIZE - 24*/
/*typedef unsigned char bufferT [FSIZE-24];*/

/*
BASIC file format:
offset:
0	lower byte of file size
1	higher byte of file size
2       01h
3..10   BASIC file name
11..18  Password
19	BASE-N MODE then 01h else 00h
20      00h
21	first character of BASIC program
.....
nn-1    last character of BASIC program
nn      00h
nn+1    lower byte of file size
nn+2	higher byte of file size
*/

/*writes buffer to memory address*/
/*uses FSIZE to determine size of buffer*/
/*this is was my older way to save data to file*/
/*void buffer_write (bufferT buf,unsigned int seg,unsigned int ofs) {
  unsigned int count;
  for (count=0;count<FSIZE;count++) {
    pokeb (seg,ofs+count,buf [count]);
  }
}*/

int search_string (char *str, unsigned int seg,unsigned int ofs,
                               unsigned int *r_seg ,unsigned int *r_ofs ) {
/*
   search_string searches for a string pointed by str.
   seg:ofs - from this address function start to search for string
   return: 0 - found succesfully. r_seg:r_ofs - contain returned address.
           1 - no matches found. r_seg = r_ofs = 0
*/
  unsigned int index;/*counts number of matches.*/
  char length=strlen (str);/*length of searched string.*/
  index=0;
  for (;seg<LASTSEGM;seg+=NXTSEG/16) {
    do {
      index=0;
      while ( (peekb (seg,ofs+index)==str [index]) ) {
        index++;
        if (index==length) {/* A match was found!*/
                             *r_seg=seg;
                             *r_ofs=ofs;
                             return 0;
	                   };
      }/*while*/
      ofs++;
    } while (ofs<NXTSEG);
    ofs=0;
  }
 *r_seg=0;
 *r_ofs=0;
 return 1;
} /*proc*/

/*  if open_file would return addres wchich offset would be less then 3
    then file format check would check bad addres (65535-3 or so)
    so offset must be within (3...65535-filesize).
    BUT FUNCTION BELOW DOESN'T DO IT RIGHT!!!
*/
void address_modif (unsigned int *seg, unsigned int *ofs, unsigned int fsize) {
  int n;
  if (*ofs<3) {
    (*seg)--;
    (*ofs)+=16;
  } else
  if ((*ofs)>65535-fsize) {
    n=(65535-fsize)/16;
    (*seg)+=n;
    (*ofs)+=fsize;
    puts ("Address modif may fail.");
  }
}

int open_file (char *FileName, unsigned int FileSize, unsigned int *r_segP, unsigned int *r_ofsP) {
/* searches for basic file, then
   return:
     0 - everything went O'k
         *r_segP:*r_ofsP - address of first character which would be normally
	                   visible in CASIO's editor.
     1 - file not found
     2 - file was found, but it's size does not match
*/
  if (search_string (FileName,BASIC_SEG,0,r_segP,r_ofsP)!=0)
    return 1;
  address_modif (r_segP,r_ofsP,FileSize);
  if ( ((unsigned char)peekb (*r_segP,*r_ofsP-1)!=1)||
       ((unsigned char)peekb (*r_segP,*r_ofsP-2)!=FileSize/256)||/*higher*/
       ((unsigned char)peekb (*r_segP,*r_ofsP-3)!=FileSize%256)/*lower*/
     ) return 2;
  if ( ((unsigned char)peekb (*r_segP,*r_ofsP+FileSize-3-3)!=0)||
       ((unsigned char)peekb (*r_segP,*r_ofsP+FileSize-3-2)!=FileSize%256)||/*lower*/
       ((unsigned char)peekb (*r_segP,*r_ofsP+FileSize-3-1)!=FileSize/256)/*higher*/
     ) return 2;
  /* seting pointer to the first character in basic file */
  *r_ofsP+=18;
  return 0;
}